LoadPackage("atlasrep");
LoadPackage("io");

checkD_random := function(gr, x, n)
  local sg, i, t, y;
  Print("Trying with n=", n, "\n");
  for i in [1..n] do
  	t := Random(gr);
    y := t*x*Inverse(t);
    if not (x*y)^2 = (y*x)^2 then 
      sg := Subgroup(gr, [x,y]);
      if IsConjugate(sg, x, y) = false then
        return [x,y];
      fi;
    fi;
  od;
  return fail;
end;

checkD := function(gr, c)
  local sg, x, y;
  x := Representative(c);
  for y in c do
    if not (x*y)^2 = (y*x)^2 then 
      sg := Subgroup(gr, [x,y]);
      if IsConjugate(sg, x, y) = false then
        return [x,y];
      fi;
    fi;
  od;
  return fail;
end;

x := [];
g := [];

M := 19;
file := Concatenation("max", String(M));

LogTo("M19.log");

Print("Group Fi24'.2, maximal: ", file, "\n\n");

G76 := Image(IsomorphismPermGroup(SmallGroup(7*6, 1)));
_gr := DirectProduct(G76, SymmetricGroup(7)); 
_cc := ConjugacyClasses(_gr);

f := IO_File("M19.rec", "w");
IO_WriteLine(f,"### The format for classinfo is [ r, s, order, comment ]");
IO_WriteLine(f,"data := rec(");
IO_WriteLine(f,"  group := \"", file, "\",");
IO_WriteLine(f,"  generators := \"", GeneratorsOfGroup(_gr), "\",");
IO_WriteLine(f,"  comments := \"Maximal subgroups\",");
IO_WriteLine(f,"  classinfo := [");

for c in _cc do
  g := Representative(c);

  if not Order(g) in [6, 12, 42, 84] then
    continue;
  fi;

  Print("Representative of order ", Order(g), "\n");
  rs := checkD(_gr, c); 
  Print(" Conjugacy class of size: ", Size(c), "\n");
  Print(" Centralizer of order: ", Size(_gr)/Size(c), "\n");
  if not rs = fail then
    IO_WriteLine(f, "    [ ", rs[1], ", ", rs[2], ", ", Order(g), ", \"D\" ],");
    Print("Removed!\n");
  else
    Print("Fail!\n");
  fi;
  Print("--\n");
od;

IO_WriteLine(f, "  ]");
IO_WriteLine(f, ");");
IO_Flush(f);
IO_Close(f);


